Summary: Throttleable lightweight httpd server
Name: thttpd
Version: 2.00
Release: 2
Group: Networking
URL: http://www.acme.com/software/thttpd
Source0: thttpd-%{PACKAGE_VERSION}.tar.gz
Source1: thttpd.init
Copyright: distributable (BSD)
BuildRoot: /tmp/thttpd-root

%description
Thttpd is a very compact no-frills httpd serving daemon that can handle
very high loads.  While lacking many of the advanced features of
Apachee, thttpd operates without forking and is extremely efficient in
memory use.  Basic support for cgi scripts, authentication, and ssi is
provided for.  Advanced features include the ability to throttle traffic.

%prep
export PATH=/bin:/usr/bin:$PATH
TMP=`grep ^httpd: /etc/passwd ; exit 0`
if [ "$TMP" = "" ]; then
   while [ -r /etc/.pwd.lock ]; do sleep 5 ; done
   touch /etc/.pwd.lock
   cp -a /etc/passwd /etc/passwd-
   IF_UID=20
   while grep "[^:]*:[^:]*:$IF_UID:.*" /etc/passwd > /dev/null
   do IF_UID=`expr $IF_UID + 1` ; done
   IF_GID=`grep ^httpd: /etc/group | cut -d':' -f3`
   if [ "$IF_GID" = "" ]; then 	  
   	IF_GID=20
   	cp -a /etc/group /etc/group-
   	while grep "[^:]*:[^:]*:$IF_GID:.*" /etc/group > /dev/null
   	do IF_GID=`expr $IF_GID + 1` ; done
	echo "httpd:x:$IF_GID:httpd" >>/etc/group
   fi
   echo "httpd:*:${IF_UID}:${IF_GID}:httpd:/home/httpd:" >> /etc/passwd
   rm /etc/.pwd.lock
fi


%setup
./configure --prefix=/usr
%build
make WEBDIR=/home/httpd BINDIR=/usr/sbin prefix=/usr CGIBINDIR=/home/httpd/cgi-bin

%install
mkdir -p $RPM_BUILD_ROOT/home/httpd/cgi-bin
chown httpd /home/httpd
chgrp httpd /home/httpd
chmod 0775 /home/httpd
mkdir -p $RPM_BUILD_ROOT/etc/rc.d/init.d
mkdir -p $RPM_BUILD_ROOT/etc/rc.d/rc0.d
mkdir -p $RPM_BUILD_ROOT/etc/rc.d/rc1.d
mkdir -p $RPM_BUILD_ROOT/etc/rc.d/rc2.d
mkdir -p $RPM_BUILD_ROOT/etc/rc.d/rc3.d
mkdir -p $RPM_BUILD_ROOT/etc/rc.d/rc4.d
mkdir -p $RPM_BUILD_ROOT/etc/rc.d/rc5.d
mkdir -p $RPM_BUILD_ROOT/etc/rc.d/rc6.d
mkdir -p $RPM_BUILD_ROOT/usr/man/man8
mkdir -p $RPM_BUILD_ROOT/usr/man/man1
mkdir -p $RPM_BUILD_ROOT/usr/sbin
WEBDIR=$RPM_BUILD_ROOT/home/httpd 
BINDIR=$RPM_BUILD_ROOT/usr/sbin
MANDIR=$RPM_BUILD_ROOT/usr/man 
CGIBINDIR=$RPM_BUILD_ROOT/home/httpd/cgi-bin
cp $RPM_SOURCE_DIR/thttpd.init $RPM_BUILD_ROOT/etc/rc.d/init.d/thttpd
install -m 0550 -o httpd -g httpd -s thttpd $BINDIR
install thttpd.8 $MANDIR/man8
install -s -o httpd -g httpd cgi-src/nph-redirect cgi-src/phf cgi-src/ssi $CGIBINDIR
install cgi-src/nph-redirect.8 $MANDIR/man8
install cgi-src/ssi.8 $MANDIR/man8
install -s -m 02755 -o httpd -g httpd extras/makeweb $BINDIR
install extras/makeweb.1 $MANDIR/man1
install extras/htpasswd.1 $MANDIR/man1
install extras/syslogtocern.8 $MANDIR/man8
install -s extras/htpasswd extras/syslogtocern $BINDIR
cd $RPM_BUILD_ROOT/etc/rc.d/rc0.d ; ln -sf ../init.d/thttpd K15thttpd 
cd $RPM_BUILD_ROOT/etc/rc.d/rc1.d ; ln -sf ../init.d/thttpd K15thttpd
cd $RPM_BUILD_ROOT/etc/rc.d/rc2.d ; ln -sf ../init.d/thttpd K15thttpd
cd $RPM_BUILD_ROOT/etc/rc.d/rc3.d ; ln -sf ../init.d/thttpd S85thttpd
cd $RPM_BUILD_ROOT/etc/rc.d/rc4.d ; ln -sf ../init.d/thttpd S85thttpd
cd $RPM_BUILD_ROOT/etc/rc.d/rc5.d ; ln -sf ../init.d/thttpd S85thttpd
cd $RPM_BUILD_ROOT/etc/rc.d/rc6.d ; ln -sf ../init.d/thttpd K15thttpd
%files
%doc FILES README INSTALL TODO
/etc/rc.d/init.d/thttpd
/etc/rc.d/rc0.d/K15thttpd
/etc/rc.d/rc1.d/K15thttpd
/etc/rc.d/rc2.d/K15thttpd
/etc/rc.d/rc3.d/S85thttpd
/etc/rc.d/rc4.d/S85thttpd
/etc/rc.d/rc5.d/S85thttpd
/etc/rc.d/rc6.d/K15thttpd
/usr/sbin/thttpd
/usr/sbin/makeweb
/usr/sbin/htpasswd
/usr/sbin/syslogtocern
/home/httpd
/usr/man/man8/thttpd.8
/usr/man/man1/makeweb.1
/usr/man/man8/ssi.8
/usr/man/man1/htpasswd.1
/usr/man/man8/nph-redirect.8
/usr/man/man8/syslogtocern.8

